/***************************************************************************************
	Copyright 2000-2001 ATMEL Corporation.
	
	This file is part of atmel wireless lan drivers.

    Atmel wireless lan drivers is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Atmel wireless lan drivers is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Atmel wireless lan drivers; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**************************************************************************************/
// xvnet_tabs. Tabs structures...
typedef struct {
	FL_FORM *errorform;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *exit;
	FL_OBJECT *message;
}FD_errorform;

typedef struct {
	FL_FORM *alertform;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *exit;
	FL_OBJECT *Retry;
	FL_OBJECT *message;
}FD_alertform;

typedef struct {
	FL_FORM *mainform;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *timer;
	FL_OBJECT *exit;
	FL_OBJECT *folder;
	FL_OBJECT *eth_select;
} FD_mainform;

typedef struct {
	FL_FORM *monitorform;
	void *vdata;
	char *cdata;
	long ldata;
	FL_OBJECT *OpMode;
	FL_OBJECT *Channel;
	FL_OBJECT *Change;
	FL_OBJECT *Submit;
	FL_OBJECT *Cancel;
	FL_OBJECT *SSID;
	FL_OBJECT *TxRate;
	FL_OBJECT *Radio;//For Radio
	FL_OBJECT *Roaming;//For Roaming
	FL_OBJECT *Power;
	FL_OBJECT *mac;
	FL_OBJECT *State;	
	FL_OBJECT *Signal_b; //for bar;
	FL_OBJECT *Link_b;
}FD_monitorform;

typedef struct {
	FL_FORM *statisticsform;
	void *vdata;
	char *cdata;
	long ldata;
	FL_OBJECT *DTxSucc;
	FL_OBJECT *DRxSucc;
	FL_OBJECT *DTxUnS;
	FL_OBJECT *DRxUnS;
	FL_OBJECT *MTxSucc;
	FL_OBJECT *MRxSucc;
	FL_OBJECT *MTxUnS;
	FL_OBJECT *MRxUnS;
	FL_OBJECT *ReJTx;
	FL_OBJECT *ReJRx;
}FD_statisticsform;

typedef struct {
	FL_FORM *sitesurveyform;
	void *vdata;
	char *cdata;
	long ldata;
	FL_OBJECT *browser;
	FL_OBJECT *Select;
	FL_OBJECT *ReScan;
	FL_OBJECT *Cancel;
	FL_OBJECT *Timer;
}FD_sitesurveyform;

typedef struct {
	FL_FORM *encryptionform;
	void *vdata;
	char *cdata;
	long ldata;
	FL_OBJECT *EncryptionLevel;
	FL_OBJECT *Wep1;
	FL_OBJECT *Wep2;
	FL_OBJECT *Wep3;
	FL_OBJECT *Wep4;
	FL_OBJECT *WepToUse;
	FL_OBJECT *WepMode;
	FL_OBJECT *AuthType;
	FL_OBJECT *Submit;
}FD_encryptionform;

typedef struct {
	FL_FORM *advancedform;
	void *vdata;
	char *cdata;
	long ldata;
	FL_OBJECT *frag_sl;
	FL_OBJECT *frag_input;
	FL_OBJECT *frag_ed;
	FL_OBJECT *rts_sl;
	FL_OBJECT *rts_input;
	FL_OBJECT *rts_ed;
	FL_OBJECT *b_on;//For Radio
	FL_OBJECT *b_off;//For Radio
	FL_OBJECT *b_long;
	FL_OBJECT *b_short;
}FD_advancedform;

typedef struct {
	FL_FORM *versionform;
	void *vdata;
	char *cdata;
	long ldata;	
}FD_versionform;
